// TConnection.h: interface for the TConnection class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TDORER2CONNECTION_H__76B7A462_8821_11D1_B242_0000C09B5CBE__INCLUDED_)
#define AFX_TDORER2CONNECTION_H__76B7A462_8821_11D1_B242_0000C09B5CBE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "TConnection.h"

class TProposition;
class TScreenParamsNetwork;
class TEnergySpreader;
class TNetworkParams;

/*-----------------------------------------------------------------------------
Class   : Dorer2 Connections
Date    : 19.11.98
-------------------------------------------------------------------------------
Description: special classes to treat Dorer connections
-----------------------------------------------------------------------------*/

class TDorer2SituationLink : public TConnection
{
	public:
		TDorer2SituationLink(TNetworkParams* params, TProposition* src, TProposition *dest);

		virtual double		GetActivation();
		virtual BOOL		IsDrawn(TScreenParamsNetwork* pScreen);
		virtual void		SetMaxActivation();
		virtual void		DoCreatePen(CPen& pen, COLORREF cCol) { pen.CreatePen(PS_DASH, 1, cCol); };
};


class TDorer2GoalLink : public TConnection
{
	public:
		TDorer2GoalLink(TNetworkParams* params, TProposition* src, TProposition *dest);

		virtual double		GetActivation();
		virtual BOOL		IsDrawn(TScreenParamsNetwork* pScreen);
		virtual void		SetMaxActivation();
};


class TDorer2ProtectedGoalLink : public TConnection
{
	public:
		TDorer2ProtectedGoalLink(TNetworkParams* params, TProposition* src, TProposition *dest);

		virtual double		GetActivation();
		virtual BOOL		IsDrawn(TScreenParamsNetwork* pScreen);
		virtual void		SetMaxActivation();
		virtual void		DoCreatePen(CPen& pen, COLORREF cCol) { pen.CreatePen(PS_DOT, 1, cCol); };
};


class TDorer2SuccessorLink : public TConnection
{
	public:
		TDorer2SuccessorLink(TNetworkParams* params, TProposition* src, TProposition *dest);

		virtual double		GetActivation();
		virtual BOOL		IsDrawn(TScreenParamsNetwork* pScreen);
		virtual void		SetMaxActivation();
		virtual void		DrawLink(CDC* pDC, TScreenParamsNetwork* pScreen) { DrawInternalLink(pDC, pScreen); };
		virtual	int		GetBending() { return TConnection::GetBending() + 10; };

		double	GetGoalActivation(int iGoalIndex);
};


class TDorer2ConflictorLink : public TConnection
{
	public:
		TDorer2ConflictorLink(TNetworkParams* params, TProposition* src, TProposition *dest);

		virtual double		GetActivation();
		virtual BOOL		IsDrawn(TScreenParamsNetwork* pScreen);
		virtual void		SetMaxActivation();
		virtual void		DrawLink(CDC* pDC, TScreenParamsNetwork* pScreen) { DrawInternalLink(pDC, pScreen); };
		virtual void		DoCreatePen(CPen& pen, COLORREF cCol) { pen.CreatePen(PS_DOT, 1, cCol); };

		double	GetGoalActivation(int iGoalIndex);
};


class TResourceLink : public TConnection
{
	public:
		TResourceLink(TNetworkParams* params, TProposition* src, TProposition *dest);

		virtual BOOL		IsDrawn(TScreenParamsNetwork* pScreen);
};

#endif // !defined(AFX_TDORER2CONNECTION_H__76B7A462_8821_11D1_B242_0000C09B5CBE__INCLUDED_)
