// TGoal.h: interface for the TGoal class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TDORER2GOAL_H__76B7A464_8821_11D1_B242_0000C09B5CBE__INCLUDED_)
#define AFX_TDORER2GOAL_H__76B7A464_8821_11D1_B242_0000C09B5CBE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "TGoal.h"
#include <math.h>

class TDorer2Network;

/*-----------------------------------------------------------------------------
Class   : TDorer2Goal
Date    : 08.01.98
-------------------------------------------------------------------------------
Base Class: TGoal

Description: represents a goal of an agent
-----------------------------------------------------------------------------*/

class TDorer2Goal : public TGoal
{
	public:
		TDorer2Goal();
		virtual ~TDorer2Goal();

		virtual BOOL		ParseGoal(LPCTSTR goal, TPercept* pPerceptionFactory);
		virtual void		DrawModule(CDC* pDC, TScreenParamsNetwork* pScreen);
		virtual double		GetActivation();
		double				GetRelevance() const { return m_dRelevance; };
		void					SetRelevance(double rel) { m_dRelevance = rel; };
		void					CalculateSituationRelevance();
		BOOL					AddRelevanceCondition(LPCTSTR name, BOOL bNegated, TPercept* pPerceptionFactory);
		void					SetNetwork(TDorer2Network* net) { m_pNetwork = net; };

	protected:
		double			m_dRelevance;
		CObList*			m_pRelevanceList;
		CObList*			m_pEffectsList;
		TDorer2Network* m_pNetwork;		// only needed for risky choice
};	

#endif // !defined(AFX_TDORER2GOAL_H__76B7A464_8821_11D1_B242_0000C09B5CBE__INCLUDED_)
