// TGoal.h: interface for the TGoal class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TGOAL_H__76B7A464_8821_11D1_B242_0000C09B5CBE__INCLUDED_)
#define AFX_TGOAL_H__76B7A464_8821_11D1_B242_0000C09B5CBE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "TEnergySpreader.h"

class TPropostion;
class TPercept;
class TParseString;

/*-----------------------------------------------------------------------------
Class   : TGoal
Date    : 08.01.98
-------------------------------------------------------------------------------
Base Class: TEnergySpreader

Description: represents a goal of an agent
-----------------------------------------------------------------------------*/

class TGoal : public TEnergySpreader  
{
	public:
		TGoal(void);
		TGoal(int index);
		virtual ~TGoal();

		BOOL					ParseGoalName(TParseString& parse, TPercept* pPerceptionFactory);

		virtual BOOL		ParseGoal(LPCTSTR goal, TPercept* pPerceptionFactory);
		virtual void		DrawModule(CDC* pDC, TScreenParamsNetwork* pScreen);
		virtual double		GetActivation() { return m_dImportance; };
		TProposition*		GetCondition() { return m_pCondition; };
		void					SetImportance(double imp);

		// for blocksworld
		BOOL					SetBlockworldGoal(LPCTSTR name, BOOL bNegated, TPercept* pPerceptionFactory);

	protected:
		double			m_dImportance;
		TProposition*	m_pCondition;
};	

#endif // !defined(AFX_TGOAL_H__76B7A464_8821_11D1_B242_0000C09B5CBE__INCLUDED_)
