#if !defined(AFX_TNETWORKVIEW_H__6493A6C1_9BE1_11D1_B242_0000C09B5CBE__INCLUDED_)
#define AFX_TNETWORKVIEW_H__6493A6C1_9BE1_11D1_B242_0000C09B5CBE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// TNetworkView.h : header file
//

class TScreenParamsNetwork;
class TBehaviorNetwork;
class TEnergySpreader;

/////////////////////////////////////////////////////////////////////////////
// TNetworkView view


class DLL_CLASS TNetworkView : public CView
{
public:
	TNetworkView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(TNetworkView)

// Attributes
private:
	TScreenParamsNetwork*		m_pScreen;
	TBehaviorNetwork*	m_pNetwork;
	TEnergySpreader*	m_pSelectedModule;
	BOOL					m_bNoGraphics;
	BOOL					m_bDrawAtEndOfActionSelection;

// Operations
public:

	void				SetSelectedModule(TEnergySpreader* current);
	void				SetNetwork(TBehaviorNetwork* pNet);
	void				RedrawView();
	TScreenParamsNetwork*	GetScreenParams();
	void				SetNoGraphics(BOOL val);
	BOOL				GetDrawAtEndOfActionSelection();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(TNetworkView)
	protected:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~TNetworkView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(TNetworkView)
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnNetnames();
	afx_msg void OnUpdateNetnames(CCmdUI* pCmdUI);
	afx_msg void OnNetzoomIn();
	afx_msg void OnUpdateNetzoomIn(CCmdUI* pCmdUI);
	afx_msg void OnNetzoomOut();
	afx_msg void OnUpdateNetzoomOut(CCmdUI* pCmdUI);
	afx_msg void OnViewConflictors();
	afx_msg void OnUpdateViewConflictors(CCmdUI* pCmdUI);
	afx_msg void OnViewPredecessors();
	afx_msg void OnUpdateViewPredecessors(CCmdUI* pCmdUI);
	afx_msg void OnViewSuccessors();
	afx_msg void OnUpdateViewSuccessors(CCmdUI* pCmdUI);
	afx_msg void OnNetviewAtEnd();
	afx_msg void OnUpdateNetviewAtEnd(CCmdUI* pCmdUI);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnNetViewSelected();
	afx_msg void OnUpdateNetViewSelected(CCmdUI* pCmdUI);
	afx_msg void OnViewNetActivation();
	afx_msg void OnUpdateViewNetActivation(CCmdUI* pCmdUI);
	afx_msg void OnNetParams();
	afx_msg void OnUpdateNetParams(CCmdUI* pCmdUI);
	afx_msg void OnNetDrawGoalTracking();
	afx_msg void OnUpdateNetDrawGoalTracking(CCmdUI* pCmdUI);
	afx_msg void OnViewNetConActivation();
	afx_msg void OnUpdateViewNetConActivation(CCmdUI* pCmdUI);
	afx_msg void OnNetSingleStep();
	afx_msg void OnUpdateNetSingleStep(CCmdUI* pCmdUI);
	afx_msg void OnNetSqeezeY();
	afx_msg void OnUpdateNetSqeezeY(CCmdUI* pCmdUI);
	afx_msg void OnNetSqueezeX();
	afx_msg void OnUpdateNetSqueezeX(CCmdUI* pCmdUI);
	afx_msg void OnNetStretchX();
	afx_msg void OnUpdateNetStretchX(CCmdUI* pCmdUI);
	afx_msg void OnNetStretchY();
	afx_msg void OnUpdateNetStretchY(CCmdUI* pCmdUI);
	afx_msg void OnViewNetZeroLink();
	afx_msg void OnUpdateViewNetZeroLink(CCmdUI* pCmdUI);
	afx_msg void OnNetAction();
	afx_msg void OnUpdateNetAction(CCmdUI* pCmdUI);
	afx_msg void OnNetActionHistory();
	afx_msg void OnUpdateNetActionHistory(CCmdUI* pCmdUI);
	afx_msg void OnDrawResourceLink();
	afx_msg void OnUpdateDrawResourceLink(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TNETWORKVIEW_H__6493A6C1_9BE1_11D1_B242_0000C09B5CBE__INCLUDED_)
