// TScreenParamsNetwork.h: interface for the TScreenParamsNetwork class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TScreenParamsNetwork_H__89781B21_5CDE_11D1_B242_0000C09B5CBE__INCLUDED_)
#define AFX_TScreenParamsNetwork_H__89781B21_5CDE_11D1_B242_0000C09B5CBE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


#define DEFAULT_MIDX 300
#define DEFAULT_MIDY 100
#define DEFAULT_SCALEX 1.0
#define DEFAULT_SCALEY 3.0

/*-----------------------------------------------------------------------------
Class   : TScreenParamsNetwork
Date    : 15.05.96
-------------------------------------------------------------------------------
Base Class: CObject

Description: controls the screen sccaling and translation
-----------------------------------------------------------------------------*/

class TScreenParamsNetwork : public CObject  
{
	public:
		TScreenParamsNetwork();
		virtual ~TScreenParamsNetwork();

		int		GetMitteX(void) { return m_tMiddle.x; };
		int		GetMitteY(void) { return m_tMiddle.y; };
		double	GetScale(void) { return m_dScale; };
		void		SetScale(double scale) { m_dScale = scale; };
		double	GetAbsScale(void) { return m_dAbsScale; };
		void		SetAbsScale(double scale) { m_dAbsScale = scale; };
		void		SetSize(CSize size) { m_tSize = size; };
		CSize		GetSize() const { return m_tSize; };

		void		SetParams(int sizex, int sizey, double scalex);
		void		SetMid(int x, int y) { m_tMiddle.x = x; m_tMiddle.y = y; };
		void		Scale(double factor) { m_dScale *= factor; };

		void		SetDrawNames(BOOL val) { m_bDrawNames = val; };
		BOOL		GetDrawNames(void) const { return m_bDrawNames; };
		void		SetDrawActivations(BOOL val) { m_bDrawActivations = val; };
		BOOL		GetDrawActivations(void) const { return m_bDrawActivations; };
		void		SetDrawConnectionActivations(BOOL val) { m_bDrawConnectionActivations = val; };
		BOOL		GetDrawConnectionActivations(void) const { return m_bDrawConnectionActivations; };
		void		SetDrawActionHistory(BOOL val) { m_bDrawActionHistory = val; };
		BOOL		GetDrawActionHistory(void) const { return m_bDrawActionHistory; };
		void		SetDrawGoalTracking(BOOL val) { m_bDrawGoalTracking = val; };
		BOOL		GetDrawGoalTracking(void) const { return m_bDrawGoalTracking; };
		void		SetDrawZeroLinks(BOOL val) { m_bDrawZeroLinks = val; };
		BOOL		GetDrawZeroLinks(void) { return m_bDrawZeroLinks; };
		void		SetJustDrawSelectedConnections(BOOL val) { m_bJustDrawSelectedConnections = val; };
		BOOL		GetJustDrawSelectedConnections(void) const { return m_bJustDrawSelectedConnections; };
		void		SetDrawSuccessors(BOOL val) { m_bDrawSuccessors = val; };
		BOOL		GetDrawSuccessors(void) { return m_bDrawSuccessors; };
		void		SetDrawPredecessors(BOOL val) { m_bDrawPredecessors = val; };
		BOOL		GetDrawPredecessors(void) { return m_bDrawPredecessors; };
		void		SetDrawConflictors(BOOL val) { m_bDrawConflictors = val; };
		BOOL		GetDrawConflictors(void) { return m_bDrawConflictors; };
		void		SetDrawResourceLinks(BOOL val) { m_bDrawResourceLinks = val; };
		BOOL		GetDrawResourceLinks(void) { return m_bDrawResourceLinks; };

		void		SetTranslation(CPoint point) { m_tTranslate = point; };
		void		Translate(CPoint point) { m_tTranslate += point; };
		CPoint	GetTranslation() { return m_tTranslate; };

		int		GetStretchX() { return m_iStretchX; };
		int		GetStretchY() { return m_iStretchY; };
		void		StretchX(int val) { m_iStretchX += val; if (m_iStretchX < 1) m_iStretchX = 1; };
		void		StretchY(int val) { m_iStretchY += val * 10; if (m_iStretchY < -60) m_iStretchY = -60; };

	private:
		double	m_dScale;
		double	m_dAbsScale;
		CSize		m_tSize;
		CPoint	m_tTranslate;
		CPoint	m_tMiddle;
		int		m_iStretchX;
		int		m_iStretchY;

		BOOL		m_bDrawNames;			// for TNetworkView
		BOOL		m_bDrawActivations;
		BOOL		m_bDrawConnectionActivations;
		BOOL		m_bDrawGoalTracking;
		BOOL		m_bDrawActionHistory;
		BOOL		m_bJustDrawSelectedConnections;
		BOOL		m_bDrawSuccessors;
		BOOL		m_bDrawPredecessors;
		BOOL		m_bDrawZeroLinks;
		BOOL		m_bDrawConflictors;
		BOOL		m_bDrawResourceLinks;

};

#endif // !defined(AFX_TScreenParamsNetwork_H__89781B21_5CDE_11D1_B242_0000C09B5CBE__INCLUDED_)
