// TValue.h: interface for the TValue class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TVALUE_H__C1067581_BE42_11D1_B242_0000C09B5CBE__INCLUDED_)
#define AFX_TVALUE_H__C1067581_BE42_11D1_B242_0000C09B5CBE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


/*-----------------------------------------------------------------------------
Class   : TValue
Date    : 18.03.98
-------------------------------------------------------------------------------
Base Class: CObject

Description: used to capsule the fuzzy &
-----------------------------------------------------------------------------*/

class TValue// : public CObject  
{
	public:
		TValue() { m_dValue = 0.0; };
		TValue(double val) { m_dValue = val; };
		TValue(TValue& val) { m_dValue = val.GetValue(); };
		virtual ~TValue() {};

		double GetValue() const { return m_dValue; };
		BOOL	 GetBinary(double border) const { if (m_dValue < border) return FALSE; else return TRUE; };

		friend TValue operator& (double val1, TValue& val2);
		friend TValue operator& (TValue& val1, double val2);
		friend TValue operator& (TValue& val1, TValue& val2);

		friend TValue operator+ (double val1, TValue& val2);
		friend TValue operator+ (TValue& val1, double val2);
		friend TValue operator+ (TValue& val1, TValue& val2);
		friend TValue operator- (double val1, TValue& val2);
		friend TValue operator- (TValue& val1, double val2);
		friend TValue operator- (TValue& val1, TValue& val2);
		friend TValue operator* (double val1, TValue& val2);
		friend TValue operator* (TValue& val1, double val2);
		friend TValue operator* (TValue& val1, TValue& val2);
		friend TValue operator/ (double val1, TValue& val2);
		friend TValue operator/ (TValue& val1, double val2);
		friend TValue operator/ (TValue& val1, TValue& val2);
		BOOL operator == (const TValue& val) { return (m_dValue == val.GetValue()); };
		BOOL operator == (double val) { return (m_dValue == val); };
		BOOL operator > (const TValue& val) { return (m_dValue > val.GetValue()); };
		BOOL operator > (double val) { return (m_dValue > val); };
		BOOL operator < (const TValue& val) { return (m_dValue < val.GetValue()); };
		BOOL operator < (double val) { return (m_dValue < val); };
		
		TValue operator = (const TValue& val) { return TValue(m_dValue = val.GetValue()); };
		TValue operator = (double val) { return TValue(m_dValue = val); };

		const TValue& operator += (const TValue& val) { m_dValue += val.GetValue(); return *this; };
		const TValue& operator += (double val) { m_dValue += val;  return *this; };
		const TValue& operator -= (const TValue& val) { m_dValue -= val.GetValue();  return *this; };
		const TValue& operator -= (double val) { m_dValue -= val;  return *this; };
		const TValue& operator *= (const TValue& val) { m_dValue *= val.GetValue();  return *this; };
		const TValue& operator *= (double val) { m_dValue *= val;  return *this; };
		const TValue& operator /= (TValue& val) { m_dValue /= val.GetValue();  return *this; };
		const TValue& operator /= (double val) { m_dValue /= val;  return *this; };

		operator double() { return m_dValue; };
		operator int() { return (int)m_dValue; };
			
	private:

		double	m_dValue;
};

#endif // !defined(AFX_TVALUE_H__C1067581_BE42_11D1_B242_0000C09B5CBE__INCLUDED_)
