// GeneticCode.h: interface for the GeneticCode class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GENETICCODE_H__6A1CCBEE_0871_4052_94E4_639F42418217__INCLUDED_)
#define AFX_GENETICCODE_H__6A1CCBEE_0871_4052_94E4_639F42418217__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define SIZE_OF_CODE			6
#define MUTATION_RATE			1.0
#define MUTATION_PROBABILITY	0.1

class TParseString;

class GeneticCode : public CObject 
{
   DECLARE_SERIAL( GeneticCode )

	public:
		GeneticCode();
		GeneticCode(GeneticCode* other);
		GeneticCode(double quality, double* code, double* range);
		virtual ~GeneticCode();

		void			Serialize( CArchive& archive );
		
		GeneticCode*	CrossOver(GeneticCode* other);
		double			Mutate(double value, double range);
		GeneticCode*	CreateRandomCode();

		CString			ToString();
		void			FromString(TParseString& code);


		// parameters
		double		m_parameters[SIZE_OF_CODE];
		double		m_range[SIZE_OF_CODE];
		double		m_quality;
		double		m_varianz;
		int			m_age;

	private:
		double			CreateRandomValue(double value, double range);


};

#endif // !defined(AFX_GENETICCODE_H__6A1CCBEE_0871_4052_94E4_639F42418217__INCLUDED_)
