// TArea.h: interface for the TArea class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TAREA_H__9B4A4061_2E12_11D3_A173_006008E88C8E__INCLUDED_)
#define AFX_TAREA_H__9B4A4061_2E12_11D3_A173_006008E88C8E__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class TVector;

class TArea  
{
	public:
		TArea() {};
		TArea(TVector& leftTop, TVector& rightBottom) { SetArea(leftTop, rightBottom); };
		TArea(TVector& leftTop, double width, double length)
		{ SetArea(leftTop, TVector(leftTop.GetX() + width, leftTop.GetY() + length)); };
		
		void		SetArea(TVector& leftTop, TVector& rightBottom) 
					{ m_tLeftTop = leftTop; m_tRightBottom = rightBottom; };

		void		Rotate(TVector& center, int angle);
		void		Rotate(int angle);
		void		Translate(TVector& trans);
		
		BOOL		InArea(TVector& point);

		// Attributes
		double	GetWidth();
		double	GetLength();


	private:
		TVector	m_tLeftTop;
		TVector	m_tRightBottom;
};

#endif // !defined(AFX_TAREA_H__9B4A4061_2E12_11D3_A173_006008E88C8E__INCLUDED_)
