// TDirection.cpp: implementation of the TDirection class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Basis.h"
#include "TDirection.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

void TDirection::CheckRange()
{
	if (m_iDirection == NOT_EXISTING)
		return;
	if (m_iDirection > 180)
		m_iDirection -= 360;
	else if (m_iDirection <= -180)
		m_iDirection += 360;
}

TDirection TDirection::Abs(void)
{
	if (m_iDirection < 0)
		m_iDirection = - m_iDirection;
	return *this;
}

BOOL TDirection::LiesWithin(TDirection& dir1, TDirection& dir2)
{
	// checks if this direction lies within dir1 and dir2, where
	// dir1 is assumed to be left of dir2
	int	thisDir = GetDirection();
	if (dir1.IsLeftOf(dir2))
		if (dir1 < dir2)
			if ((thisDir >= (int)dir1) && (thisDir <= (int)dir2))
				return TRUE;
			else
				return FALSE;
		else
			// we are at the -180/180 border
			if ((thisDir >= (int)dir1) || (thisDir <= (int)dir2))
				return TRUE;
			else
				return FALSE;
	else
		return FALSE;
}

BOOL TDirection::IsLeftOf(TDirection& dir2)
{
	int	dir1 = GetDirection();
	int	d2 = dir2.GetDirection();

	if (((dir1 < d2) && (dir1 > d2 - 180)) || (dir1 > d2 + 180))
		return TRUE;
	else
		return FALSE;
}

BOOL TDirection::IsRightOf(TDirection& dir2)
{
	int	dir1 = GetDirection();
	int	d2 = dir2.GetDirection();

	if (((dir1 > d2) && (dir1 < d2 - 180)) || (dir1 < d2 + 180))
		return TRUE;
	else
		return FALSE;
}


TDirection operator+ (int val1, TDirection& val2) 
{ 
	TDirection	dir(val1 + val2.GetDirection());
	dir.CheckRange();
	return TDirection(dir);
}

TDirection operator+ (TDirection& val1, int val2)
{ 
	TDirection	dir(val1.GetDirection() + val2);
	dir.CheckRange();
	return TDirection(dir);
}

TDirection operator+ (TDirection& val1, TDirection& val2)
{ 
	TDirection	dir(val1.GetDirection() + val2.GetDirection());
	dir.CheckRange();
	return TDirection(dir);
}

TDirection operator-(int val1, TDirection& val2)
{ 
	TDirection	dir(val1 - val2.GetDirection());
	dir.CheckRange();
	return TDirection(dir);
}

TDirection operator-(TDirection& val1, int val2)
{ 
	TDirection	dir(val1.GetDirection() - val2);
	dir.CheckRange();
	return TDirection(dir);
}

TDirection operator- (TDirection& val1, TDirection& val2)
{ 
	TDirection	dir(val1.GetDirection() - val2.GetDirection());
	dir.CheckRange();
	return TDirection(dir);
}

TDirection operator*(int val1, TDirection& val2)
{ 
	TDirection	dir(val1 * val2.GetDirection());
	dir.CheckRange();
	return TDirection(dir);
}

TDirection operator* (TDirection& val1, int val2)
{ 
	TDirection	dir(val1.GetDirection() * val2);
	dir.CheckRange();
	return TDirection(dir);
}


