// TPerceptionParser.cpp: implementation of the TPerceptionParser class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Basis.h"
#include ".\BehaviorNet\TParseString.h"
#include "TPerceptionParser.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TPerceptionParser::TPerceptionParser()
{

}

TPerceptionParser::~TPerceptionParser()
{

}



/**
 * Called when any other that the previos messages arrived such as init or error
 *
 * @param message	unparsed message of the server
 */
void TPerceptionParser::ParseParameters(LPCTSTR message, int count, double* parameters)
{
	TParseString	tokenizer(message);
	CString			temp;

	// overread (player_param
	tokenizer.ParseString(temp);

	// read all parameters
	for (int i = 0; i < count; i++)
	{
		parameters[i] = tokenizer.ParseDouble();
		if (tokenizer.HasErrorOccured())
		{
			#ifdef _DEBUG
				TRACE1("Error Parsing parameters  %s\r\n", message);
			#endif
			return;
		}
	}
}


BOOL TPerceptionParser::ParseChangedPlayer(LPCTSTR str, int* ret)
{
	TParseString	tokenizer(str);
	CString			temp;

	// overread (change_player_type num type)
	tokenizer.ParseString(temp);
	ret[0] = tokenizer.ParseInteger();
	ret[1] = tokenizer.ParseInteger();
	if (tokenizer.HasErrorOccured())
		return FALSE;
	else
		return TRUE;
}

/*
public void onScore(String message)
{
	StringTokenizer	tokenizer = new StringTokenizer(message, ") ");

	try {
		// (score time 3 1)
		tokenizer.nextToken();
		int	 time  = Integer.parseInt(tokenizer.nextToken());
		int	 left  = Integer.parseInt(tokenizer.nextToken());
		int	 right = Integer.parseInt(tokenizer.nextToken());

		m_agent.onScore(time, left, right);

	} catch (Exception e) {
		System.out.println("Error parsing change player information: " + message);
	}
}
*/